/*
 *	Serial port driver (uses bit-banging)
 *	for 16Cxx series parts.
 *
 * 	IMPORTANT: Compile this file with FULL optimization
 *
 *	Copyright (C)1996 HI-TECH Software.
 *	Freely distributable.
 */
 
// HI-TECH C ̃CXg[tH_ samples\serial\bitbang\serial.c gp
//
// 2010N828 TvQlɏ
//
// 
// uts@kyoutan.jpn.org
// http://kyoutan.jpn.org/uts/

#include	<htc.h>
#include	"iosetting.h"
#include	"ps2.h"
#include "convprocess.h"
#include "serial.h"


/*	Baud rate	*/
#define	BRATE	2400
#define LENGTH_1BIT ((_XTAL_FREQ/4000000)*(1000000/BRATE))

/*	Transmit and Receive port bits */
#define	TxData		TxD			/* Map TxData to pin */
#define	RxData		RxD				/* Map RxData to pin */

unsigned char	rxbuff;	// MWX^

void putch(char data)
{
unsigned char count;

	count=9;
	TxData = 0;	// X^[grbg
	_delay(LENGTH_1BIT-6);
	while(1)
	{
		TxData = (data & 1);
		data = (data >> 1) | 0b10000000;	// Xgbvrbgu߂ɍŏʃrbg1ɂĂ
		_delay(LENGTH_1BIT-24);
		if(--count==0)break;
	}
}

bit rxloop(void)
{
unsigned char count;

	while(1)
	{	// X^[grbg邽߂̃[v́Ał邾ŉ񂷁B\ȂAO荞݂ŃX^[grbg悤ɂ炢
		if(RxData==0)
		{
			// X^[grbg
			_delay((LENGTH_1BIT / 2 ) -5 -10);	// rbg҂iZ߂̕j
			if(RxData==0)
			{
				// X^[grbgmF
				count=8;
				_delay(LENGTH_1BIT-3);
				while(1)
				{
					rxbuff=((rxbuff >> 1) | (RxData << 7));	// 8rbgMB
					_delay(LENGTH_1BIT-14);
					if(--count==0)break;
				}
				if(RxData==0)
				{
					return 1;	// Xgbvrbg 0  t[~OG[
				}
				else
				{
					X68_READY=0;	// M X68 L[𑗐M֎~
					return 0;
				}
			}
		}

		if(PS2_CLKIN==1)
		{
			if(PS2_DATAIN==0)	// ps2 zXg̑Mv
			{
				//X68_READY=0;	// X68 L[𑗐M֎~ɂāAPS2 ̎M
				ps2hostcmd();
				//X68_READY=1;
			}
		}
	}
}

char getch(void)
{
	X68_READY=1;
	while(rxloop());	// ͂܂ő҂
	return rxbuff;
}
