// PS2 L[{[h̒ʐM
//
// OADG eNjJEt@X n[hEFA http://www.oadg.or.jp/tosho/index.htm#techref
// 
// http://hp.vector.co.jp/authors/VA037406/html/ps2interface.htm
// http://ioio.at.infoseek.co.jp/PS2/PS2.HTML
// Qlɂ
//
// 2010N905 MŃNbN񑽂oĂ̂CAƓ
// 2010N827 쐬
//
// 
// uts@kyoutan.jpn.org
// http://kyoutan.jpn.org/uts/


#include	<htc.h>
#include	"iosetting.h"
#include	"ps2.h"
#include	"serial.h"
#include "convprocess.h"

#define delay_ms(x) __delay_ms(x)
#define delay_us(x) __delay_us(x)



//	O[oϐ
unsigned char	ps2data;	// Mp
unsigned char	resenddata; // đMR}hp

//bit ps2txerr;

bit	ps2datafound;
bit parityerror;
bit	framingerror;
bit	readdata;




void ps2_por(void)	// power-on reset
{
	delay_ms(1000);
}




void ps2_setdefault(void)
{
	INTCON=0b00000000;	// 荞ݑS֎~
	OPTION=0b10001000;	// PBvAbvȂ vXP[WDTɐڑiTMR0ŎgȂj

// |[g̏
//	PORTA = 0;
//	PORTB = 0;
	TxD		= 1;
	PS2_CLKOUT	= 0;
	PS2_DATAOUT	= 0;

// I/O|[ǧ
//	TRISA=0x00;	// So͂ɐݒ
//	TRISB=0x00;

	RxD_Dir			= 1;	// in
	TxD_Dir			= 0;	// out
	X68_READY_Dir	= 0;	// out

	PS2_CLKOUT_Dir	= 0;	// out
	PS2_CLKIN_Dir	= 1;	// in
	PS2_DATAOUT_Dir	= 0;	// out
	PS2_DATAIN_Dir	= 1;	// in

	ptrsc=0;	// tONA
	
	resenddata=0xFE;
	
	//putch(0xFF);	// LED S
	//X68_READY=1;	//	X68L[{[hf[^o
}




void ps2_bat(void)	// basic assurance test)
{
	ps2_setdefault();

// LEDS_
	putch(0b10000000);

	delay_ms(300);

// LED S
	putch(0b11111111);

	ps2transmit(0xAA);	// ZteXgR[h
// R[hPOR450ms2.5s̊ԁAуZbgER}hAckim艞j300`500ms̊ԂɑM܂B

//	X68_READY=1;	//	X68L[{[hf[^o
}




void readbit(void)	// zXgfoCXւ̑Mf[^́ANbNM̗œǍ܂
{
	delay_us(10);	// 15			// NbNHighLoẘeԂ30SEC50SEC
	readdata=PS2_DATAIN;
	PS2_CLKOUT=1;
	delay_us(40);	// 30
	PS2_CLKOUT=0;
	delay_us(20);
}

void dataout_0(void)	// foCXzXgւ̑Mf[^́ANbNM̗GbWœǍ܂
{
	PS2_DATAOUT=1;
	delay_us(15);	// 15
	PS2_CLKOUT=1;
	delay_us(40);	// 30
	PS2_CLKOUT=0;
	delay_us(10); // 10
}

void dataout_1(void)
{
	PS2_DATAOUT=0;
	delay_us(15);
	PS2_CLKOUT=1;
	delay_us(40);
	PS2_CLKOUT=0;
	delay_us(10);
}




// -----------------------------------------------------------------------------
// -----------------------------------------------------------------------------
//	PS/2
//	M
//	߂l	0:X^[grbgȂAMɃzXg璆fꂽ
//			1:MsBpeBG[At[~OG[̏ꍇ
//				Ŏv񂾂ǁAُI 0 ԂāAςˁBʋtˁB
//
//	̑̏Ԃ̓WX^ŕԂ
//	unsigned char	ps2data;	Mp̃f[^WX^
//	bit	ps2datafound;	1:Mf[^L
//	bit parityerror;	1:peB[G[
//	bit	framingerror;	1:t[~OG[	peBG[ƃt[~OG[AzXgɑ΂čđMR}h𔭍s
//

bit ps2receive(void)
{
unsigned char	parity,count;
unsigned char	retrycount;

	retrycount=4;
retry:
	PS2_DATAOUT=0;
	PS2_CLKOUT=0;

	parityerror=0;
	framingerror=0;
	ps2datafound=0;

	delay_us(250);
	if(PS2_DATAIN==1) return 0;	// X^[grbg炸I

	parityerror=1;	// G[tO𗧂Ă

	if(PS2_CLKIN==0) return 0;	// L[{[h

	parity=1;	// ͂ 1 ̎ 1 ƁAbit0 peBɂȂ

	count=9;
	while(1)			// X^[grbg{f[^ 9 rbg荞ށBX^[grbĝ͎Ă
	{					// for 肱̂قR[hTCY 10[h炢k܂
		readbit();
		if(readdata==1) parity++;
		ps2data=(ps2data >> 1) | (readdata << 7);	// ͂obt@̍ŏʂɃZbg
		if(PS2_CLKIN==0) return 0;	// zXg璆fꂽ

		if(--count==0)break;	// count=count-1 ʂ[Ȃ break
	}

	readbit();
	if(readdata==(parity & 1)) parityerror=0;	// peB`FbN

	if(PS2_DATAIN==0){	// Xgbvrbĝ͂ 0 At[~OG[
		framingerror=1;
		count=255;
		while(1){	// DAT  1 ɂȂ܂ŃNbNoB[vɂȂ獢̂ŁAŒ 255 
			readbit();
			if(readdata==1) break;
			if(--count==0) break;
		}
	}

		// Mł
	dataout_0();	//  0 óiMj
	PS2_DATAOUT=0;
	
	if((parityerror==1) | (framingerror==1))
	{
		if(--retrycount==0)goto givup;
		ps2transmit(0xFE);	// đMv
		goto retry;
	}
	
	ps2datafound=1;	// f[^L
	
	delay_us(200);

givup:
	return 1;	// I
}



// -----------------------------------------------------------------------------
// -----------------------------------------------------------------------------
//	PS/2
//	M
//	߂l	0:zXg璆fꂽ
//			1:I
//

bit ps2transmit(unsigned char data)
{
unsigned char	parity,count;

	if(data!=0xFE) resenddata=data;	// đMR}hȊO̎
//	ps2txerr=1;

	PS2_CLKOUT=0;
	PS2_DATAOUT=0;
	
	// zXgL[{[hɂĂȂׂ
	// L[{[hA܂ő҂
	while(1)
	{
		if(PS2_CLKIN==1) break;
	}

	// zXgMvoĂȂׂ
	if(PS2_DATAIN==0)goto txerror;

	dataout_0();	// X^[grbgo

	parity=1;
	count=8;
	while(1)	// f[^ 8 rbgo
	{
		if(PS2_CLKIN==0)	// ُI
		{
			goto txerror;
		}

		if((data & 1)==0) 
		{
			dataout_0();
		}
		else
		{
			dataout_1();
			parity++;
		}

		data=data >> 1;

		if(--count==0)break;
	}

	if(PS2_CLKIN==0)	// ُIBpeBoOɃ`FbN邱ƁB
	{
		goto txerror;
	}

	if((parity & 1)==0)	// peBrbgo
		dataout_0();
	else
		dataout_1();

	dataout_1();	// Xgbvrbgo

//	ps2txerr=0;

	// zXgL[{[hɂĂȂׂ
	// L[{[hA܂ő҂
	while(1)
	{
		if(PS2_CLKIN==1) break;
	}

	return 1;	// I

txerror:
	PS2_CLKOUT=0;		// |[g L ̏ԂŏIȂ悤ɂ
	PS2_DATAOUT=0;
	return 0;
}
